// BonSrcDecoder.h: CBonSrcDecoder NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#pragma once


#include "MediaDecoder.h"
#include "IBonDriver.h"
#include "IBonDriver2.h"


/////////////////////////////////////////////////////////////////////////////
// Bon\[XfR[_(`[iTSXg[M)
/////////////////////////////////////////////////////////////////////////////
// Output	#0	: CMediaData		TSXg[
/////////////////////////////////////////////////////////////////////////////

class CBonSrcDecoder : public CMediaDecoder
{
public:
	// G[R[h
	enum {
		ERR_NOERROR,		// G[Ȃ
		ERR_DRIVER,			// hCoG[
		ERR_TUNEROPEN,		// `[iI[vG[
		ERR_TUNER,			// `[iG[
		ERR_NOTOPEN,		// `[iJĂȂ
		ERR_ALREADYOPEN,	// `[iɊJĂ
		ERR_NOTPLAYING,		// ĐĂȂ
		ERR_ALREADYPLAYING,	// ɍĐĂ
		ERR_TIMEOUT,		// ^CAEg
		ERR_INTERNAL		// G[
	};

	CBonSrcDecoder(IEventHandler *pEventHandler = NULL);
	virtual ~CBonSrcDecoder();

// IMediaDecoder
	virtual void Reset(void);
	virtual const bool InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex = 0UL);

// CBonSrcDecoder
	const bool OpenTuner(HMODULE hBonDrvDll);
	const bool CloseTuner(void);
	const bool IsOpen() const;

	const bool Play(void);
	const bool Stop(void);

	const bool SetChannel(const BYTE byChannel);
	const bool SetChannel(const DWORD dwSpace, const DWORD dwChannel);
	const bool SetChannelAndPlay(const DWORD dwSpace, const DWORD dwChannel);
	const float GetSignalLevel(void);

	const bool IsBonDriver2(void) const;
	LPCTSTR GetSpaceName(const DWORD dwSpace) const;
	LPCTSTR GetChannelName(const DWORD dwSpace, const DWORD dwChannel) const;

	const bool PurgeStream(void);

	// Append by HDUSTest̒̐l
	int NumSpaces() const;
	LPCTSTR GetTunerName() const;
	int GetCurSpace() const;
	int GetCurChannel() const;
	DWORD GetBitRate() const;
	DWORD GetStreamRemain() const;
	bool SetStreamThreadPriority(int Priority);
	int GetStreamThreadPriority() const { return m_StreamThreadPriority; }
	void SetPurgeStreamOnChannelChange(bool bPurge);
	bool IsPurgeStreamOnChannelChange() const { return m_bPurgeStreamOnChannelChange; }

private:
	static DWORD WINAPI StreamRecvThread(LPVOID pParam);
	bool LockStream();
	void UnlockStream();

	IBonDriver *m_pBonDriver;
	IBonDriver2 *m_pBonDriver2;	

	HANDLE m_hStreamRecvThread;
	CCriticalLock m_StreamLock;
	volatile bool m_bKillSignal;
	volatile bool m_bPauseSignal;

	volatile bool m_bIsPlaying;
	DWORD m_dwLastError;

	CBitRateCalculator m_BitRateCalculator;
	DWORD m_StreamRemain;

	int m_StreamThreadPriority;
	bool m_bPurgeStreamOnChannelChange;
};
